Index: Sections/DVDCodec.cs
===================================================================
--- Sections/DVDCodec.cs	(revision 28260)
+++ Sections/DVDCodec.cs	(working copy)
@@ -266,10 +266,8 @@
       // 
       // groupBox1
       // 
-      this.groupBox1.Anchor =
-        ((System.Windows.Forms.AnchorStyles)
-         (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-           | System.Windows.Forms.AnchorStyles.Right)));
+      this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.groupBox1.Controls.Add(this.mpLabel1);
       this.groupBox1.Controls.Add(this.checkBoxDXVA);
       this.groupBox1.Controls.Add(this.audioRendererLabel);
@@ -294,7 +292,7 @@
       this.mpLabel1.AutoSize = true;
       this.mpLabel1.Location = new System.Drawing.Point(165, 49);
       this.mpLabel1.Name = "mpLabel1";
-      this.mpLabel1.Size = new System.Drawing.Size(281, 13);
+      this.mpLabel1.Size = new System.Drawing.Size(305, 13);
       this.mpLabel1.TabIndex = 10;
       this.mpLabel1.Text = "Note: Use corresponding decoders with chosen Navigator";
       // 
@@ -304,8 +302,8 @@
       this.checkBoxDXVA.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
       this.checkBoxDXVA.Location = new System.Drawing.Point(19, 185);
       this.checkBoxDXVA.Name = "checkBoxDXVA";
-      this.checkBoxDXVA.Size = new System.Drawing.Size(333, 17);
-      this.checkBoxDXVA.TabIndex = 9;
+      this.checkBoxDXVA.Size = new System.Drawing.Size(359, 17);
+      this.checkBoxDXVA.TabIndex = 6;
       this.checkBoxDXVA.Text = "Turn off DxVA (use this option if you have DVD navigation issues)";
       this.checkBoxDXVA.UseVisualStyleBackColor = true;
       // 
@@ -319,17 +317,15 @@
       // 
       // audioRendererComboBox
       // 
-      this.audioRendererComboBox.Anchor =
-        ((System.Windows.Forms.AnchorStyles)
-         (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-           | System.Windows.Forms.AnchorStyles.Right)));
+      this.audioRendererComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.audioRendererComboBox.BorderColor = System.Drawing.Color.Empty;
       this.audioRendererComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.audioRendererComboBox.Location = new System.Drawing.Point(168, 120);
       this.audioRendererComboBox.Name = "audioRendererComboBox";
       this.audioRendererComboBox.Size = new System.Drawing.Size(278, 21);
       this.audioRendererComboBox.Sorted = true;
-      this.audioRendererComboBox.TabIndex = 5;
+      this.audioRendererComboBox.TabIndex = 4;
       // 
       // videoCodecLabel
       // 
@@ -341,17 +337,15 @@
       // 
       // videoCodecComboBox
       // 
-      this.videoCodecComboBox.Anchor =
-        ((System.Windows.Forms.AnchorStyles)
-         (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-           | System.Windows.Forms.AnchorStyles.Right)));
+      this.videoCodecComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.videoCodecComboBox.BorderColor = System.Drawing.Color.Empty;
       this.videoCodecComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.videoCodecComboBox.Location = new System.Drawing.Point(168, 72);
       this.videoCodecComboBox.Name = "videoCodecComboBox";
       this.videoCodecComboBox.Size = new System.Drawing.Size(278, 21);
       this.videoCodecComboBox.Sorted = true;
-      this.videoCodecComboBox.TabIndex = 1;
+      this.videoCodecComboBox.TabIndex = 2;
       // 
       // checkBoxAC3
       // 
@@ -359,38 +353,34 @@
       this.checkBoxAC3.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
       this.checkBoxAC3.Location = new System.Drawing.Point(19, 156);
       this.checkBoxAC3.Name = "checkBoxAC3";
-      this.checkBoxAC3.Size = new System.Drawing.Size(275, 17);
-      this.checkBoxAC3.TabIndex = 8;
+      this.checkBoxAC3.Size = new System.Drawing.Size(295, 17);
+      this.checkBoxAC3.TabIndex = 5;
       this.checkBoxAC3.Text = "Use AC3 filter (for some soundcards using SPDIF out)";
       this.checkBoxAC3.UseVisualStyleBackColor = true;
       // 
       // dvdNavigatorComboBox
       // 
-      this.dvdNavigatorComboBox.Anchor =
-        ((System.Windows.Forms.AnchorStyles)
-         (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-           | System.Windows.Forms.AnchorStyles.Right)));
+      this.dvdNavigatorComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.dvdNavigatorComboBox.BorderColor = System.Drawing.Color.Empty;
       this.dvdNavigatorComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.dvdNavigatorComboBox.Location = new System.Drawing.Point(168, 24);
       this.dvdNavigatorComboBox.Name = "dvdNavigatorComboBox";
       this.dvdNavigatorComboBox.Size = new System.Drawing.Size(278, 21);
       this.dvdNavigatorComboBox.Sorted = true;
-      this.dvdNavigatorComboBox.TabIndex = 3;
+      this.dvdNavigatorComboBox.TabIndex = 1;
       // 
       // audioCodecComboBox
       // 
-      this.audioCodecComboBox.Anchor =
-        ((System.Windows.Forms.AnchorStyles)
-         (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-           | System.Windows.Forms.AnchorStyles.Right)));
+      this.audioCodecComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.audioCodecComboBox.BorderColor = System.Drawing.Color.Empty;
       this.audioCodecComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.audioCodecComboBox.Location = new System.Drawing.Point(168, 96);
       this.audioCodecComboBox.Name = "audioCodecComboBox";
       this.audioCodecComboBox.Size = new System.Drawing.Size(278, 21);
       this.audioCodecComboBox.Sorted = true;
-      this.audioCodecComboBox.TabIndex = 7;
+      this.audioCodecComboBox.TabIndex = 3;
       // 
       // dvdNavigatorLabel
       // 
@@ -417,6 +407,7 @@
       this.groupBox1.ResumeLayout(false);
       this.groupBox1.PerformLayout();
       this.ResumeLayout(false);
+
     }
 
     #endregion
Index: Sections/MovieCodec.Designer.cs
===================================================================
--- Sections/MovieCodec.Designer.cs	(revision 28260)
+++ Sections/MovieCodec.Designer.cs	(working copy)
@@ -82,7 +82,7 @@
       this.aacAudioCodecComboBox.Name = "aacAudioCodecComboBox";
       this.aacAudioCodecComboBox.Size = new System.Drawing.Size(278, 21);
       this.aacAudioCodecComboBox.Sorted = true;
-      this.aacAudioCodecComboBox.TabIndex = 15;
+      this.aacAudioCodecComboBox.TabIndex = 4;
       // 
       // autoDecoderSettings
       // 
@@ -91,8 +91,8 @@
       this.autoDecoderSettings.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
       this.autoDecoderSettings.Location = new System.Drawing.Point(19, 156);
       this.autoDecoderSettings.Name = "autoDecoderSettings";
-      this.autoDecoderSettings.Size = new System.Drawing.Size(309, 30);
-      this.autoDecoderSettings.TabIndex = 0;
+      this.autoDecoderSettings.Size = new System.Drawing.Size(341, 30);
+      this.autoDecoderSettings.TabIndex = 6;
       this.autoDecoderSettings.Text = "Automatic Decoder Settings \r\n(use with caution - knowledge of DirectShow merits r" +
           "equired)";
       this.autoDecoderSettings.UseVisualStyleBackColor = true;
@@ -116,7 +116,7 @@
       this.h264videoCodecComboBox.Name = "h264videoCodecComboBox";
       this.h264videoCodecComboBox.Size = new System.Drawing.Size(278, 21);
       this.h264videoCodecComboBox.Sorted = true;
-      this.h264videoCodecComboBox.TabIndex = 9;
+      this.h264videoCodecComboBox.TabIndex = 2;
       this.h264videoCodecComboBox.SelectedIndexChanged += new System.EventHandler(this.h264videoCodecComboBox_SelectedIndexChanged);
       // 
       // audioRendererComboBox
@@ -129,7 +129,7 @@
       this.audioRendererComboBox.Name = "audioRendererComboBox";
       this.audioRendererComboBox.Size = new System.Drawing.Size(278, 21);
       this.audioRendererComboBox.Sorted = true;
-      this.audioRendererComboBox.TabIndex = 7;
+      this.audioRendererComboBox.TabIndex = 5;
       // 
       // label3
       // 
@@ -185,9 +185,9 @@
       this.mpLabelNote.AutoSize = true;
       this.mpLabelNote.Location = new System.Drawing.Point(106, 26);
       this.mpLabelNote.Name = "mpLabelNote";
-      this.mpLabelNote.Size = new System.Drawing.Size(247, 13);
+      this.mpLabelNote.Size = new System.Drawing.Size(265, 13);
       this.mpLabelNote.TabIndex = 2;
-      this.mpLabelNote.Text = "All .ts files will be played using TV codecs settings !";
+      this.mpLabelNote.Text = "All .ts files will be played using TV codecs settings!";
       // 
       // mpGroupBox2
       // 
Index: Sections/TVCodec.Designer.cs
===================================================================
--- Sections/TVCodec.Designer.cs	(revision 28260)
+++ Sections/TVCodec.Designer.cs	(working copy)
@@ -76,7 +76,7 @@
       this.ddplusAudioCodecComboBox.Name = "ddplusAudioCodecComboBox";
       this.ddplusAudioCodecComboBox.Size = new System.Drawing.Size(278, 21);
       this.ddplusAudioCodecComboBox.Sorted = true;
-      this.ddplusAudioCodecComboBox.TabIndex = 15;
+      this.ddplusAudioCodecComboBox.TabIndex = 5;
       // 
       // labelDDPLUSDecoder
       // 
@@ -96,7 +96,7 @@
       this.audioCodecComboBox.Name = "audioCodecComboBox";
       this.audioCodecComboBox.Size = new System.Drawing.Size(278, 21);
       this.audioCodecComboBox.Sorted = true;
-      this.audioCodecComboBox.TabIndex = 5;
+      this.audioCodecComboBox.TabIndex = 3;
       // 
       // labelAACDecoder
       // 
@@ -116,7 +116,7 @@
       this.aacAudioCodecComboBox.Name = "aacAudioCodecComboBox";
       this.aacAudioCodecComboBox.Size = new System.Drawing.Size(278, 21);
       this.aacAudioCodecComboBox.Sorted = true;
-      this.aacAudioCodecComboBox.TabIndex = 13;
+      this.aacAudioCodecComboBox.TabIndex = 4;
       // 
       // h264videoCodecComboBox
       // 
@@ -128,7 +128,7 @@
       this.h264videoCodecComboBox.Name = "h264videoCodecComboBox";
       this.h264videoCodecComboBox.Size = new System.Drawing.Size(278, 21);
       this.h264videoCodecComboBox.Sorted = true;
-      this.h264videoCodecComboBox.TabIndex = 3;
+      this.h264videoCodecComboBox.TabIndex = 2;
       this.h264videoCodecComboBox.SelectedIndexChanged += new System.EventHandler(this.h264videoCodecComboBox_SelectedIndexChanged);
       // 
       // labelH264Decoder
@@ -186,7 +186,7 @@
       this.audioRendererComboBox.Name = "audioRendererComboBox";
       this.audioRendererComboBox.Size = new System.Drawing.Size(278, 21);
       this.audioRendererComboBox.Sorted = true;
-      this.audioRendererComboBox.TabIndex = 7;
+      this.audioRendererComboBox.TabIndex = 6;
       // 
       // mpGroupBox2
       // 
@@ -206,9 +206,9 @@
       this.mpLabelNote.AutoSize = true;
       this.mpLabelNote.Location = new System.Drawing.Point(104, 26);
       this.mpLabelNote.Name = "mpLabelNote";
-      this.mpLabelNote.Size = new System.Drawing.Size(247, 13);
+      this.mpLabelNote.Size = new System.Drawing.Size(265, 13);
       this.mpLabelNote.TabIndex = 2;
-      this.mpLabelNote.Text = "All .ts files will be played using TV codecs settings !";
+      this.mpLabelNote.Text = "All .ts files will be played using TV codecs settings!";
       // 
       // TVCodec
       // 